from __future__ import annotations

import datetime
from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field
from dateutil.parser import isoparse

from ..types import UNSET, Unset

T = TypeVar("T", bound="TpaTransactionCreateBody")


@_attrs_define
class TpaTransactionCreateBody:
    """
    Attributes:
        statement_id (str): MongoDB ObjectId
        date (datetime.datetime | Unset):
        description (str | Unset):
        amount (float | Unset):
        tx_type (str | Unset):
        tx_sub_type (str | Unset):
        page (float | Unset):
    """

    statement_id: str
    date: datetime.datetime | Unset = UNSET
    description: str | Unset = UNSET
    amount: float | Unset = UNSET
    tx_type: str | Unset = UNSET
    tx_sub_type: str | Unset = UNSET
    page: float | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        statement_id = self.statement_id

        date: str | Unset = UNSET
        if not isinstance(self.date, Unset):
            date = self.date.isoformat()

        description = self.description

        amount = self.amount

        tx_type = self.tx_type

        tx_sub_type = self.tx_sub_type

        page = self.page

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "statementId": statement_id,
            }
        )
        if date is not UNSET:
            field_dict["date"] = date
        if description is not UNSET:
            field_dict["description"] = description
        if amount is not UNSET:
            field_dict["amount"] = amount
        if tx_type is not UNSET:
            field_dict["txType"] = tx_type
        if tx_sub_type is not UNSET:
            field_dict["txSubType"] = tx_sub_type
        if page is not UNSET:
            field_dict["page"] = page

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        statement_id = d.pop("statementId")

        _date = d.pop("date", UNSET)
        date: datetime.datetime | Unset
        if isinstance(_date, Unset):
            date = UNSET
        else:
            date = isoparse(_date)

        description = d.pop("description", UNSET)

        amount = d.pop("amount", UNSET)

        tx_type = d.pop("txType", UNSET)

        tx_sub_type = d.pop("txSubType", UNSET)

        page = d.pop("page", UNSET)

        tpa_transaction_create_body = cls(
            statement_id=statement_id,
            date=date,
            description=description,
            amount=amount,
            tx_type=tx_type,
            tx_sub_type=tx_sub_type,
            page=page,
        )

        tpa_transaction_create_body.additional_properties = d
        return tpa_transaction_create_body

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
